.586
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include gdi32.inc
includelib gdi32.lib

;***************************************************************************************************

grab proto hWin:HWND

;***************************************************************************************************

.const
clippy      db "Clippy",0
notepad     db "notepad",0
done        db "Grabbed!",0
err404      db "Notepad window not found",0

.code
start:
    invoke FindWindow, ADDR notepad,NULL
    .IF (eax)
        invoke grab, eax
        invoke MessageBox, NULL,ADDR done,ADDR clippy,MB_OK or MB_ICONINFORMATION
    .ELSE
        invoke MessageBox, NULL,ADDR err404,ADDR clippy,MB_OK or MB_ICONERROR
    .ENDIF
    invoke ExitProcess, NULL

;***************************************************************************************************

grab proc hWin:HWND
    LOCAL r:RECT
    LOCAL scrDC:HDC
    LOCAL imgBmp:HBITMAP
    LOCAL imgDC:HDC

    invoke GetDC, NULL
    mov scrDC,eax
    invoke CreateCompatibleDC, scrDC
    mov imgDC,eax
    invoke GetClientRect, hWin,ADDR r
    invoke CreateCompatibleBitmap, scrDC,[r.right],[r.bottom]
    mov imgBmp,eax
    invoke SelectObject, imgDC,imgBmp
    invoke ClientToScreen, hWin,ADDR r
    invoke BitBlt, imgDC,0,0,[r.right],[r.bottom],scrDC,[r.left],[r.top],SRCCOPY

    invoke OpenClipboard, NULL
    invoke EmptyClipboard
    invoke SetClipboardData, CF_BITMAP,imgBmp
    invoke CloseClipboard

    invoke ReleaseDC, NULL,imgDC
    invoke ReleaseDC, NULL,scrDC
    ret
grab endp

end start
